/********************************************************************************
 * Copyright (c) 2015, 2023 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 ********************************************************************************/

import { HttpClient, HttpHeaders } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { addErrorDescription } from "@core/core.functions";
import { Observable } from "rxjs";
import { catchError } from "rxjs/operators";
import { PropertyService } from "../../core/property.service";

export class ApiToken {
  id: number;
  name: string;
  created: Date;

  // only filled, if the token is generated by the server
  token: string;
}

@Injectable()
export class ApiTokenService {
  private prefEndpoint: string;

  private httpOptions = {
    headers: new HttpHeaders({
      "Content-Type": "application/json",
      Accept: "application/json",
    }),
  };

  constructor(private http: HttpClient, private _prop: PropertyService) {
    this.prefEndpoint = _prop.getUrl("mdm/apitoken");
  }

  getApiToken(id: string): Observable<ApiToken> {
    return this.http
      .get<ApiToken>(this.prefEndpoint + "/" + id)
      .pipe(catchError((e) => addErrorDescription(e, "Could not request API token!")));
  }

  getApiTokens(): Observable<ApiToken[]> {
    return this.http.get<ApiToken[]>(this.prefEndpoint).pipe(catchError((e) => addErrorDescription(e, "Could not request API tokens!")));
  }

  createApiToken(tokenName): Observable<ApiToken> {
    const requestData = {
      name: tokenName,
    };

    return this.http
      .post<ApiToken>(this.prefEndpoint, requestData, this.httpOptions)
      .pipe(catchError((e) => addErrorDescription(e, "Could not create API token!")));
  }

  deleteApiToken(id: number) {
    return this.http.delete(this.prefEndpoint + "/" + id).pipe(catchError((e) => addErrorDescription(e, "Could not delete API token!")));
  }
}
